#!/usr/bin/python
# -*- coding: UTF-8 -*-

"""
    Huawei DLI Python SDK
"""


class DliException(Exception):

    def __init__(self, msg=None, api_exception=None):
        if api_exception:
            self.status = api_exception.status
            self.body = api_exception.body
            self.reason = api_exception.reason
            self.msg = None
        else:
            self.status = None
            self.body = None
            self.reason = None
            self.msg = msg

    def __str__(self):
        """
        Custom error messages for exception
        """
        error_message = ''
        if self.status:
            error_message = "HTTP code: {0}:\n".format(self.status)

        if self.msg:
            error_message += "{0}\n".format(self.msg)

        if self.reason:
            error_message += "Reason: {0}\n".format(self.reason)

        if self.body:
            error_message += "HTTP response body: {0}\n".format(self.body)

        return error_message
