# coding: utf-8

"""
    DLI Rest API

    This is DLI Rest API

    OpenAPI spec version: v1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class RestApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def cancel_job(self, project_id, job_id, **kwargs):
        """
        Cancel job
        Canceling a job that has already been submitted can not be canceled if the job has been completed or failed.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.cancel_job(project_id, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.cancel_job_with_http_info(project_id, job_id, **kwargs)
        else:
            (data) = self.cancel_job_with_http_info(project_id, job_id, **kwargs)
            return data

    def cancel_job_with_http_info(self, project_id, job_id, **kwargs):
        """
        Cancel job
        Canceling a job that has already been submitted can not be canceled if the job has been completed or failed.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.cancel_job_with_http_info(project_id, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'job_id', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method cancel_job" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `cancel_job`")
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params) or (params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `cancel_job`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'job_id' in params:
            path_params['job_id'] = params['job_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/jobs/{job_id}', 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def cancel_job_0(self, project_id, queue_name, job_id, **kwargs):
        """
        Cancel job
        Canceling a job that has already been submitted can not be canceled if the job has been completed or failed.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.cancel_job_0(project_id, queue_name, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The current queue name, the SQL will use the current queue resources to calculate. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.cancel_job_0_with_http_info(project_id, queue_name, job_id, **kwargs)
        else:
            (data) = self.cancel_job_0_with_http_info(project_id, queue_name, job_id, **kwargs)
            return data

    def cancel_job_0_with_http_info(self, project_id, queue_name, job_id, **kwargs):
        """
        Cancel job
        Canceling a job that has already been submitted can not be canceled if the job has been completed or failed.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.cancel_job_0_with_http_info(project_id, queue_name, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The current queue name, the SQL will use the current queue resources to calculate. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'queue_name', 'job_id', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method cancel_job_0" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `cancel_job_0`")
        # verify the required parameter 'queue_name' is set
        if ('queue_name' not in params) or (params['queue_name'] is None):
            raise ValueError("Missing the required parameter `queue_name` when calling `cancel_job_0`")
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params) or (params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `cancel_job_0`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'queue_name' in params:
            path_params['queue_name'] = params['queue_name']
        if 'job_id' in params:
            path_params['job_id'] = params['job_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/queues/{queue_name}/jobs/{job_id}', 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def check_sql(self, project_id, queue_name, sql_job_info, **kwargs):
        """
        Check sql
        Check the SQL grammar.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.check_sql(project_id, queue_name, sql_job_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The name of the current queue, the SQL for the use of resources will be used to calculate the resources of the queue. (required)
        :param SQLJobRequest sql_job_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.check_sql_with_http_info(project_id, queue_name, sql_job_info, **kwargs)
        else:
            (data) = self.check_sql_with_http_info(project_id, queue_name, sql_job_info, **kwargs)
            return data

    def check_sql_with_http_info(self, project_id, queue_name, sql_job_info, **kwargs):
        """
        Check sql
        Check the SQL grammar.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.check_sql_with_http_info(project_id, queue_name, sql_job_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The name of the current queue, the SQL for the use of resources will be used to calculate the resources of the queue. (required)
        :param SQLJobRequest sql_job_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'queue_name', 'sql_job_info', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method check_sql" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `check_sql`")
        # verify the required parameter 'queue_name' is set
        if ('queue_name' not in params) or (params['queue_name'] is None):
            raise ValueError("Missing the required parameter `queue_name` when calling `check_sql`")
        # verify the required parameter 'sql_job_info' is set
        if ('sql_job_info' not in params) or (params['sql_job_info'] is None):
            raise ValueError("Missing the required parameter `sql_job_info` when calling `check_sql`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'queue_name' in params:
            path_params['queue_name'] = params['queue_name']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'sql_job_info' in params:
            body_params = params['sql_job_info']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/queues/{queue_name}/jobs/check-sql', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def commit_job(self, project_id, upload_commit_job_request, **kwargs):
        """
        Commit job
        Commit uplaod job for upload data to DLI.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.commit_job(project_id, upload_commit_job_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param UploadCommitJobRequest upload_commit_job_request: Request parameters for commit upload job (required)
        :param str x_auth_token: Authorization Token.
        :return: UploadCommitJobResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.commit_job_with_http_info(project_id, upload_commit_job_request, **kwargs)
        else:
            (data) = self.commit_job_with_http_info(project_id, upload_commit_job_request, **kwargs)
            return data

    def commit_job_with_http_info(self, project_id, upload_commit_job_request, **kwargs):
        """
        Commit job
        Commit uplaod job for upload data to DLI.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.commit_job_with_http_info(project_id, upload_commit_job_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param UploadCommitJobRequest upload_commit_job_request: Request parameters for commit upload job (required)
        :param str x_auth_token: Authorization Token.
        :return: UploadCommitJobResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'upload_commit_job_request', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method commit_job" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `commit_job`")
        # verify the required parameter 'upload_commit_job_request' is set
        if ('upload_commit_job_request' not in params) or (params['upload_commit_job_request'] is None):
            raise ValueError("Missing the required parameter `upload_commit_job_request` when calling `commit_job`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'upload_commit_job_request' in params:
            body_params = params['upload_commit_job_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/uploader/commit', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='UploadCommitJobResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def create_database(self, project_id, database_info, **kwargs):
        """
        Create database
        create a database
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_database(project_id, database_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param DatabaseInfo database_info: \"database_name\":\"dbName\",    \"description\":\"this is the database description template.\" (required)
        :param str x_auth_token: Authorization Token
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.create_database_with_http_info(project_id, database_info, **kwargs)
        else:
            (data) = self.create_database_with_http_info(project_id, database_info, **kwargs)
            return data

    def create_database_with_http_info(self, project_id, database_info, **kwargs):
        """
        Create database
        create a database
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_database_with_http_info(project_id, database_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param DatabaseInfo database_info: \"database_name\":\"dbName\",    \"description\":\"this is the database description template.\" (required)
        :param str x_auth_token: Authorization Token
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'database_info', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_database" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `create_database`")
        # verify the required parameter 'database_info' is set
        if ('database_info' not in params) or (params['database_info'] is None):
            raise ValueError("Missing the required parameter `database_info` when calling `create_database`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'database_info' in params:
            body_params = params['database_info']
        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/databases', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def create_job(self, project_id, upload_create_job_request, **kwargs):
        """
        Create job
        Create uplaod job for upload data to DLI.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_job(project_id, upload_create_job_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param UploadCreateJobRequest upload_create_job_request: Request parameters for create upload job (required)
        :param str x_auth_token: Authorization Token.
        :return: UploadCreateJobResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.create_job_with_http_info(project_id, upload_create_job_request, **kwargs)
        else:
            (data) = self.create_job_with_http_info(project_id, upload_create_job_request, **kwargs)
            return data

    def create_job_with_http_info(self, project_id, upload_create_job_request, **kwargs):
        """
        Create job
        Create uplaod job for upload data to DLI.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_job_with_http_info(project_id, upload_create_job_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param UploadCreateJobRequest upload_create_job_request: Request parameters for create upload job (required)
        :param str x_auth_token: Authorization Token.
        :return: UploadCreateJobResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'upload_create_job_request', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_job" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `create_job`")
        # verify the required parameter 'upload_create_job_request' is set
        if ('upload_create_job_request' not in params) or (params['upload_create_job_request'] is None):
            raise ValueError("Missing the required parameter `upload_create_job_request` when calling `create_job`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'upload_create_job_request' in params:
            body_params = params['upload_create_job_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/uploader/job', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='UploadCreateJobResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def create_queue(self, project_id, queue_info, **kwargs):
        """
        Create queue
        Create a queue that will bind user-specified computing resources.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_queue(project_id, queue_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param QueueInfo queue_info: Request parameters (required)
        :param str x_auth_token: Authorization Token
        :return: ResponseQueueInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.create_queue_with_http_info(project_id, queue_info, **kwargs)
        else:
            (data) = self.create_queue_with_http_info(project_id, queue_info, **kwargs)
            return data

    def create_queue_with_http_info(self, project_id, queue_info, **kwargs):
        """
        Create queue
        Create a queue that will bind user-specified computing resources.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_queue_with_http_info(project_id, queue_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param QueueInfo queue_info: Request parameters (required)
        :param str x_auth_token: Authorization Token
        :return: ResponseQueueInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'queue_info', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_queue" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `create_queue`")
        # verify the required parameter 'queue_info' is set
        if ('queue_info' not in params) or (params['queue_info'] is None):
            raise ValueError("Missing the required parameter `queue_info` when calling `create_queue`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'queue_info' in params:
            body_params = params['queue_info']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/queues', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseQueueInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def create_table(self, project_id, database_name, table_info, **kwargs):
        """
        Create a new table
        Data location:DLI and OBS，OBS must set data_location and data_type parameter
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_table(project_id, database_name, table_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: New table where the database name. (required)
        :param TableInfo table_info: New table request parameters. (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.create_table_with_http_info(project_id, database_name, table_info, **kwargs)
        else:
            (data) = self.create_table_with_http_info(project_id, database_name, table_info, **kwargs)
            return data

    def create_table_with_http_info(self, project_id, database_name, table_info, **kwargs):
        """
        Create a new table
        Data location:DLI and OBS，OBS must set data_location and data_type parameter
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_table_with_http_info(project_id, database_name, table_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: New table where the database name. (required)
        :param TableInfo table_info: New table request parameters. (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'database_name', 'table_info', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_table" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `create_table`")
        # verify the required parameter 'database_name' is set
        if ('database_name' not in params) or (params['database_name'] is None):
            raise ValueError("Missing the required parameter `database_name` when calling `create_table`")
        # verify the required parameter 'table_info' is set
        if ('table_info' not in params) or (params['table_info'] is None):
            raise ValueError("Missing the required parameter `table_info` when calling `create_table`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'database_name' in params:
            path_params['database_name'] = params['database_name']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'table_info' in params:
            body_params = params['table_info']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/databases/{database_name}/tables', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def data_authorize(self, project_id, privilege_info, **kwargs):
        """
        List queue users
        Privilege data permissions to the database or data table to other specified users.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.data_authorize(project_id, privilege_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param PrivilegeInfo privilege_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.data_authorize_with_http_info(project_id, privilege_info, **kwargs)
        else:
            (data) = self.data_authorize_with_http_info(project_id, privilege_info, **kwargs)
            return data

    def data_authorize_with_http_info(self, project_id, privilege_info, **kwargs):
        """
        List queue users
        Privilege data permissions to the database or data table to other specified users.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.data_authorize_with_http_info(project_id, privilege_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param PrivilegeInfo privilege_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'privilege_info', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method data_authorize" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `data_authorize`")
        # verify the required parameter 'privilege_info' is set
        if ('privilege_info' not in params) or (params['privilege_info'] is None):
            raise ValueError("Missing the required parameter `privilege_info` when calling `data_authorize`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'privilege_info' in params:
            body_params = params['privilege_info']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/user-authorization', 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def delete_database(self, project_id, database_name, **kwargs):
        """
        Delete database
        Delete database by database name.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_database(project_id, database_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: Delete database by this name. (required)
        :param str x_auth_token: Authorization Token
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.delete_database_with_http_info(project_id, database_name, **kwargs)
        else:
            (data) = self.delete_database_with_http_info(project_id, database_name, **kwargs)
            return data

    def delete_database_with_http_info(self, project_id, database_name, **kwargs):
        """
        Delete database
        Delete database by database name.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_database_with_http_info(project_id, database_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: Delete database by this name. (required)
        :param str x_auth_token: Authorization Token
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'database_name', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_database" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `delete_database`")
        # verify the required parameter 'database_name' is set
        if ('database_name' not in params) or (params['database_name'] is None):
            raise ValueError("Missing the required parameter `database_name` when calling `delete_database`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'database_name' in params:
            path_params['database_name'] = params['database_name']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/databases/{database_name}', 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def delete_queue(self, project_id, queue_name, **kwargs):
        """
        Delete queue
        Delete the specified queue.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_queue(project_id, queue_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The name of the queue (required)
        :param str x_auth_token: Authorization Token
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.delete_queue_with_http_info(project_id, queue_name, **kwargs)
        else:
            (data) = self.delete_queue_with_http_info(project_id, queue_name, **kwargs)
            return data

    def delete_queue_with_http_info(self, project_id, queue_name, **kwargs):
        """
        Delete queue
        Delete the specified queue.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_queue_with_http_info(project_id, queue_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The name of the queue (required)
        :param str x_auth_token: Authorization Token
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'queue_name', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_queue" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `delete_queue`")
        # verify the required parameter 'queue_name' is set
        if ('queue_name' not in params) or (params['queue_name'] is None):
            raise ValueError("Missing the required parameter `queue_name` when calling `delete_queue`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'queue_name' in params:
            path_params['queue_name'] = params['queue_name']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/queues/{queue_name}', 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def delete_table(self, project_id, database_name, table_name, **kwargs):
        """
        Delete table
        Delete the specified table.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_table(project_id, database_name, table_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: The name of the database where the table to be deleted is located. (required)
        :param str table_name: The name of the table to be deleted. (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.delete_table_with_http_info(project_id, database_name, table_name, **kwargs)
        else:
            (data) = self.delete_table_with_http_info(project_id, database_name, table_name, **kwargs)
            return data

    def delete_table_with_http_info(self, project_id, database_name, table_name, **kwargs):
        """
        Delete table
        Delete the specified table.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_table_with_http_info(project_id, database_name, table_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: The name of the database where the table to be deleted is located. (required)
        :param str table_name: The name of the table to be deleted. (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'database_name', 'table_name', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_table" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `delete_table`")
        # verify the required parameter 'database_name' is set
        if ('database_name' not in params) or (params['database_name'] is None):
            raise ValueError("Missing the required parameter `database_name` when calling `delete_table`")
        # verify the required parameter 'table_name' is set
        if ('table_name' not in params) or (params['table_name'] is None):
            raise ValueError("Missing the required parameter `table_name` when calling `delete_table`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'database_name' in params:
            path_params['database_name'] = params['database_name']
        if 'table_name' in params:
            path_params['table_name'] = params['table_name']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/databases/{database_name}/tables/{table_name}', 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def describe_table(self, project_id, database_name, table_name, **kwargs):
        """
        Describe Table
        Describes the metadata information for the specified table.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.describe_table(project_id, database_name, table_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: The name of the database where the table to be described is located. (required)
        :param str table_name: The name of the table to be described. (required)
        :param str x_auth_token: Authorization Token.
        :return: ColumnResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.describe_table_with_http_info(project_id, database_name, table_name, **kwargs)
        else:
            (data) = self.describe_table_with_http_info(project_id, database_name, table_name, **kwargs)
            return data

    def describe_table_with_http_info(self, project_id, database_name, table_name, **kwargs):
        """
        Describe Table
        Describes the metadata information for the specified table.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.describe_table_with_http_info(project_id, database_name, table_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: The name of the database where the table to be described is located. (required)
        :param str table_name: The name of the table to be described. (required)
        :param str x_auth_token: Authorization Token.
        :return: ColumnResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'database_name', 'table_name', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method describe_table" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `describe_table`")
        # verify the required parameter 'database_name' is set
        if ('database_name' not in params) or (params['database_name'] is None):
            raise ValueError("Missing the required parameter `database_name` when calling `describe_table`")
        # verify the required parameter 'table_name' is set
        if ('table_name' not in params) or (params['table_name'] is None):
            raise ValueError("Missing the required parameter `table_name` when calling `describe_table`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'database_name' in params:
            path_params['database_name'] = params['database_name']
        if 'table_name' in params:
            path_params['table_name'] = params['table_name']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/databases/{database_name}/tables/{table_name}', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ColumnResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def execute(self, project_id, sql_job_info, **kwargs):
        """
        Submit job
        This API is used to submit jobs to the cluster by executing SQL statements. The job contains the following types: DDL, DCL, IMPORT, EXPORT, QUERY, and INSERT.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.execute(project_id, sql_job_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param SQLJobRequest sql_job_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseJobInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.execute_with_http_info(project_id, sql_job_info, **kwargs)
        else:
            (data) = self.execute_with_http_info(project_id, sql_job_info, **kwargs)
            return data

    def execute_with_http_info(self, project_id, sql_job_info, **kwargs):
        """
        Submit job
        This API is used to submit jobs to the cluster by executing SQL statements. The job contains the following types: DDL, DCL, IMPORT, EXPORT, QUERY, and INSERT.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.execute_with_http_info(project_id, sql_job_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param SQLJobRequest sql_job_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseJobInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'sql_job_info', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method execute" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `execute`")
        # verify the required parameter 'sql_job_info' is set
        if ('sql_job_info' not in params) or (params['sql_job_info'] is None):
            raise ValueError("Missing the required parameter `sql_job_info` when calling `execute`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'sql_job_info' in params:
            body_params = params['sql_job_info']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/jobs/submit-job', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseJobInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def execute_0(self, project_id, queue_name, sql_job_info, **kwargs):
        """
        Submit job
        This API is used to submit jobs to the cluster by executing SQL statements. The job contains the following types: DDL, DCL, IMPORT, EXPORT, QUERY, and INSERT.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.execute_0(project_id, queue_name, sql_job_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The name of the current queue, the SQL for the use of resources will be used to calculate the resources of the queue. (required)
        :param SQLJobRequest sql_job_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseJobInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.execute_0_with_http_info(project_id, queue_name, sql_job_info, **kwargs)
        else:
            (data) = self.execute_0_with_http_info(project_id, queue_name, sql_job_info, **kwargs)
            return data

    def execute_0_with_http_info(self, project_id, queue_name, sql_job_info, **kwargs):
        """
        Submit job
        This API is used to submit jobs to the cluster by executing SQL statements. The job contains the following types: DDL, DCL, IMPORT, EXPORT, QUERY, and INSERT.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.execute_0_with_http_info(project_id, queue_name, sql_job_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The name of the current queue, the SQL for the use of resources will be used to calculate the resources of the queue. (required)
        :param SQLJobRequest sql_job_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseJobInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'queue_name', 'sql_job_info', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method execute_0" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `execute_0`")
        # verify the required parameter 'queue_name' is set
        if ('queue_name' not in params) or (params['queue_name'] is None):
            raise ValueError("Missing the required parameter `queue_name` when calling `execute_0`")
        # verify the required parameter 'sql_job_info' is set
        if ('sql_job_info' not in params) or (params['sql_job_info'] is None):
            raise ValueError("Missing the required parameter `sql_job_info` when calling `execute_0`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'queue_name' in params:
            path_params['queue_name'] = params['queue_name']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'sql_job_info' in params:
            body_params = params['sql_job_info']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/queues/{queue_name}/jobs/submit-job', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseJobInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def export_data(self, project_id, export_info, **kwargs):
        """
        Export data
        Export the data to a file. Support data export to file from DLI table, OBS table or view.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.export_data(project_id, export_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param ExportJobRequest export_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseJobInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.export_data_with_http_info(project_id, export_info, **kwargs)
        else:
            (data) = self.export_data_with_http_info(project_id, export_info, **kwargs)
            return data

    def export_data_with_http_info(self, project_id, export_info, **kwargs):
        """
        Export data
        Export the data to a file. Support data export to file from DLI table, OBS table or view.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.export_data_with_http_info(project_id, export_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param ExportJobRequest export_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseJobInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'export_info', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method export_data" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `export_data`")
        # verify the required parameter 'export_info' is set
        if ('export_info' not in params) or (params['export_info'] is None):
            raise ValueError("Missing the required parameter `export_info` when calling `export_data`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'export_info' in params:
            body_params = params['export_info']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/jobs/export-table', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseJobInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_auth(self, project_id, upload_get_auth_request, **kwargs):
        """
        Get authentication
        Get authentication info for Uploader.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_auth(project_id, upload_get_auth_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param UploadGetAuthRequest upload_get_auth_request: Request parameters for get upload auth (required)
        :param str x_auth_token: Authorization Token.
        :return: UploadGetAuthResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_auth_with_http_info(project_id, upload_get_auth_request, **kwargs)
        else:
            (data) = self.get_auth_with_http_info(project_id, upload_get_auth_request, **kwargs)
            return data

    def get_auth_with_http_info(self, project_id, upload_get_auth_request, **kwargs):
        """
        Get authentication
        Get authentication info for Uploader.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_auth_with_http_info(project_id, upload_get_auth_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param UploadGetAuthRequest upload_get_auth_request: Request parameters for get upload auth (required)
        :param str x_auth_token: Authorization Token.
        :return: UploadGetAuthResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'upload_get_auth_request', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_auth" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `get_auth`")
        # verify the required parameter 'upload_get_auth_request' is set
        if ('upload_get_auth_request' not in params) or (params['upload_get_auth_request'] is None):
            raise ValueError("Missing the required parameter `upload_get_auth_request` when calling `get_auth`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'upload_get_auth_request' in params:
            body_params = params['upload_get_auth_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/uploader/authentication', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='UploadGetAuthResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_import_export_job_info(self, project_id, job_id, **kwargs):
        """
        Import and Export detail
        Query the details of imported and exported jobs, such as the job's databaseName, tableName, file size, and export mode.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_import_export_job_info(project_id, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :return: DetailResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_import_export_job_info_with_http_info(project_id, job_id, **kwargs)
        else:
            (data) = self.get_import_export_job_info_with_http_info(project_id, job_id, **kwargs)
            return data

    def get_import_export_job_info_with_http_info(self, project_id, job_id, **kwargs):
        """
        Import and Export detail
        Query the details of imported and exported jobs, such as the job's databaseName, tableName, file size, and export mode.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_import_export_job_info_with_http_info(project_id, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :return: DetailResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'job_id', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_import_export_job_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `get_import_export_job_info`")
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params) or (params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `get_import_export_job_info`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'job_id' in params:
            path_params['job_id'] = params['job_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/jobs/{job_id}/detail', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DetailResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_job_result(self, project_id, job_id, **kwargs):
        """
        Get job result
        After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_job_result(project_id, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :param int page_size: The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10.
        :param int current_page: The current page number, the default is the first page.
        :return: JobResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_job_result_with_http_info(project_id, job_id, **kwargs)
        else:
            (data) = self.get_job_result_with_http_info(project_id, job_id, **kwargs)
            return data

    def get_job_result_with_http_info(self, project_id, job_id, **kwargs):
        """
        Get job result
        After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_job_result_with_http_info(project_id, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :param int page_size: The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10.
        :param int current_page: The current page number, the default is the first page.
        :return: JobResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'job_id', 'x_auth_token', 'page_size', 'current_page']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_job_result" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `get_job_result`")
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params) or (params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `get_job_result`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'job_id' in params:
            path_params['job_id'] = params['job_id']

        query_params = []
        if 'page_size' in params:
            query_params.append(('page-size', params['page_size']))
        if 'current_page' in params:
            query_params.append(('current-page', params['current_page']))

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/jobs/{job_id}', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='JobResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_job_result_0(self, project_id, queue_name, job_id, **kwargs):
        """
        Get job result
        After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_job_result_0(project_id, queue_name, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The current queue name, the SQL will use the current queue resources to calculate. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :param int page_size: The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10.
        :param int current_page: The current page number, the default is the first page.
        :return: JobResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_job_result_0_with_http_info(project_id, queue_name, job_id, **kwargs)
        else:
            (data) = self.get_job_result_0_with_http_info(project_id, queue_name, job_id, **kwargs)
            return data

    def get_job_result_0_with_http_info(self, project_id, queue_name, job_id, **kwargs):
        """
        Get job result
        After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_job_result_0_with_http_info(project_id, queue_name, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The current queue name, the SQL will use the current queue resources to calculate. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :param int page_size: The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10.
        :param int current_page: The current page number, the default is the first page.
        :return: JobResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'queue_name', 'job_id', 'x_auth_token', 'page_size', 'current_page']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_job_result_0" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `get_job_result_0`")
        # verify the required parameter 'queue_name' is set
        if ('queue_name' not in params) or (params['queue_name'] is None):
            raise ValueError("Missing the required parameter `queue_name` when calling `get_job_result_0`")
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params) or (params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `get_job_result_0`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'queue_name' in params:
            path_params['queue_name'] = params['queue_name']
        if 'job_id' in params:
            path_params['job_id'] = params['job_id']

        query_params = []
        if 'page_size' in params:
            query_params.append(('page-size', params['page_size']))
        if 'current_page' in params:
            query_params.append(('current-page', params['current_page']))

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/queues/{queue_name}/jobs/{job_id}', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='JobResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_job_status(self, project_id, job_id, **kwargs):
        """
        Get job status
        Get job status after job submission.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_job_status(project_id, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :return: StatusResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_job_status_with_http_info(project_id, job_id, **kwargs)
        else:
            (data) = self.get_job_status_with_http_info(project_id, job_id, **kwargs)
            return data

    def get_job_status_with_http_info(self, project_id, job_id, **kwargs):
        """
        Get job status
        Get job status after job submission.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_job_status_with_http_info(project_id, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :return: StatusResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'job_id', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_job_status" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `get_job_status`")
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params) or (params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `get_job_status`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'job_id' in params:
            path_params['job_id'] = params['job_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/jobs/{job_id}/status', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='StatusResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def import_data(self, project_id, import_export_info, **kwargs):
        """
        Import data
        Importing data from a file into a DLI table currently only supports importing data from OBS into DLI.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.import_data(project_id, import_export_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param ImportJobRequest import_export_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseJobInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.import_data_with_http_info(project_id, import_export_info, **kwargs)
        else:
            (data) = self.import_data_with_http_info(project_id, import_export_info, **kwargs)
            return data

    def import_data_with_http_info(self, project_id, import_export_info, **kwargs):
        """
        Import data
        Importing data from a file into a DLI table currently only supports importing data from OBS into DLI.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.import_data_with_http_info(project_id, import_export_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param ImportJobRequest import_export_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseJobInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'import_export_info', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method import_data" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `import_data`")
        # verify the required parameter 'import_export_info' is set
        if ('import_export_info' not in params) or (params['import_export_info'] is None):
            raise ValueError("Missing the required parameter `import_export_info` when calling `import_data`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'import_export_info' in params:
            body_params = params['import_export_info']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/jobs/import-table', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseJobInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def list_all_databases(self, project_id, **kwargs):
        """
        List all databases
        List all databases info,include owner and table_number.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_all_databases(project_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str x_auth_token: Authorization Token
        :return: DatabaseResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.list_all_databases_with_http_info(project_id, **kwargs)
        else:
            (data) = self.list_all_databases_with_http_info(project_id, **kwargs)
            return data

    def list_all_databases_with_http_info(self, project_id, **kwargs):
        """
        List all databases
        List all databases info,include owner and table_number.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_all_databases_with_http_info(project_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str x_auth_token: Authorization Token
        :return: DatabaseResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_all_databases" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `list_all_databases`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/databases', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DatabaseResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def list_all_jobs(self, project_id, **kwargs):
        """
        List all jobs
        List all jobs
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_all_jobs(project_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str x_auth_token: Authorization Token.
        :param int page_size: The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10.
        :param int current_page: The current page number, the default is the first page.
        :param int start:
        :param int end:
        :param str job_type:
        :return: JobListResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.list_all_jobs_with_http_info(project_id, **kwargs)
        else:
            (data) = self.list_all_jobs_with_http_info(project_id, **kwargs)
            return data

    def list_all_jobs_with_http_info(self, project_id, **kwargs):
        """
        List all jobs
        List all jobs
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_all_jobs_with_http_info(project_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str x_auth_token: Authorization Token.
        :param int page_size: The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10.
        :param int current_page: The current page number, the default is the first page.
        :param int start:
        :param int end:
        :param str job_type:
        :return: JobListResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'x_auth_token', 'page_size', 'current_page', 'start', 'end', 'job_type']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_all_jobs" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `list_all_jobs`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []
        if 'page_size' in params:
            query_params.append(('page-size', params['page_size']))
        if 'current_page' in params:
            query_params.append(('current-page', params['current_page']))
        if 'start' in params:
            query_params.append(('start', params['start']))
        if 'end' in params:
            query_params.append(('end', params['end']))
        if 'job_type' in params:
            query_params.append(('job-type', params['job_type']))

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/jobs', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='JobListResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def list_all_queues(self, project_id, **kwargs):
        """
        List all queues
        List all the queues under the project.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_all_queues(project_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str x_auth_token: Authorization Token
        :return: QueueResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.list_all_queues_with_http_info(project_id, **kwargs)
        else:
            (data) = self.list_all_queues_with_http_info(project_id, **kwargs)
            return data

    def list_all_queues_with_http_info(self, project_id, **kwargs):
        """
        List all queues
        List all the queues under the project.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_all_queues_with_http_info(project_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str x_auth_token: Authorization Token
        :return: QueueResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_all_queues" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `list_all_queues`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/queues', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='QueueResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def list_all_tables(self, project_id, database_name, **kwargs):
        """
        List all tables
        Query the specified database under the filter conditions or all of the table information.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_all_tables(project_id, database_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: View the database where the table name. (required)
        :param str x_auth_token: Authorization Token.
        :param str keyword: Keywords for filtering table names.
        :param bool with_detail: Whether to get the details of the table (owner, size, etc.).
        :param int page_size:
        :param int current_page:
        :param str table_type:
        :return: TableListResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.list_all_tables_with_http_info(project_id, database_name, **kwargs)
        else:
            (data) = self.list_all_tables_with_http_info(project_id, database_name, **kwargs)
            return data

    def list_all_tables_with_http_info(self, project_id, database_name, **kwargs):
        """
        List all tables
        Query the specified database under the filter conditions or all of the table information.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_all_tables_with_http_info(project_id, database_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: View the database where the table name. (required)
        :param str x_auth_token: Authorization Token.
        :param str keyword: Keywords for filtering table names.
        :param bool with_detail: Whether to get the details of the table (owner, size, etc.).
        :param int page_size:
        :param int current_page:
        :param str table_type:
        :return: TableListResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'database_name', 'x_auth_token', 'keyword', 'with_detail', 'page_size', 'current_page', 'table_type']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_all_tables" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `list_all_tables`")
        # verify the required parameter 'database_name' is set
        if ('database_name' not in params) or (params['database_name'] is None):
            raise ValueError("Missing the required parameter `database_name` when calling `list_all_tables`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'database_name' in params:
            path_params['database_name'] = params['database_name']

        query_params = []
        if 'keyword' in params:
            query_params.append(('keyword', params['keyword']))
        if 'with_detail' in params:
            query_params.append(('with-detail', params['with_detail']))
        if 'page_size' in params:
            query_params.append(('page-size', params['page_size']))
        if 'current_page' in params:
            query_params.append(('current-page', params['current_page']))
        if 'table_type' in params:
            query_params.append(('table-type', params['table_type']))

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/databases/{database_name}/tables', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='TableListResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def list_database_users(self, project_id, database_name, **kwargs):
        """
        List Database Users
        View the current database has permission to use or access all user names.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_database_users(project_id, database_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: The database name to be queried.. (required)
        :param str x_auth_token: Authorization Token.
        :return: PrivilegeResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.list_database_users_with_http_info(project_id, database_name, **kwargs)
        else:
            (data) = self.list_database_users_with_http_info(project_id, database_name, **kwargs)
            return data

    def list_database_users_with_http_info(self, project_id, database_name, **kwargs):
        """
        List Database Users
        View the current database has permission to use or access all user names.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_database_users_with_http_info(project_id, database_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: The database name to be queried.. (required)
        :param str x_auth_token: Authorization Token.
        :return: PrivilegeResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'database_name', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_database_users" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `list_database_users`")
        # verify the required parameter 'database_name' is set
        if ('database_name' not in params) or (params['database_name'] is None):
            raise ValueError("Missing the required parameter `database_name` when calling `list_database_users`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'database_name' in params:
            path_params['database_name'] = params['database_name']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/databases/{database_name}/users', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='PrivilegeResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def list_queue_users(self, project_id, queue_name, **kwargs):
        """
        List queue users
        Queries all the user names of the specified queue that can be used.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_queue_users(project_id, queue_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The name of the queue (required)
        :param str x_auth_token: Authorization Token.
        :return: PrivilegeResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.list_queue_users_with_http_info(project_id, queue_name, **kwargs)
        else:
            (data) = self.list_queue_users_with_http_info(project_id, queue_name, **kwargs)
            return data

    def list_queue_users_with_http_info(self, project_id, queue_name, **kwargs):
        """
        List queue users
        Queries all the user names of the specified queue that can be used.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_queue_users_with_http_info(project_id, queue_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str queue_name: The name of the queue (required)
        :param str x_auth_token: Authorization Token.
        :return: PrivilegeResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'queue_name', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_queue_users" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `list_queue_users`")
        # verify the required parameter 'queue_name' is set
        if ('queue_name' not in params) or (params['queue_name'] is None):
            raise ValueError("Missing the required parameter `queue_name` when calling `list_queue_users`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'queue_name' in params:
            path_params['queue_name'] = params['queue_name']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/queues/{queue_name}/users', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='PrivilegeResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def list_sql_jobs(self, project_id, **kwargs):
        """
        List all sql jobs
        List all sql jobs
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_sql_jobs(project_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str x_auth_token: Authorization Token.
        :param int page_size: The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10.
        :param int current_page: The current page number, the default is the first page.
        :return: JobListResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.list_sql_jobs_with_http_info(project_id, **kwargs)
        else:
            (data) = self.list_sql_jobs_with_http_info(project_id, **kwargs)
            return data

    def list_sql_jobs_with_http_info(self, project_id, **kwargs):
        """
        List all sql jobs
        List all sql jobs
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_sql_jobs_with_http_info(project_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str x_auth_token: Authorization Token.
        :param int page_size: The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10.
        :param int current_page: The current page number, the default is the first page.
        :return: JobListResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'x_auth_token', 'page_size', 'current_page']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_sql_jobs" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `list_sql_jobs`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []
        if 'page_size' in params:
            query_params.append(('page-size', params['page_size']))
        if 'current_page' in params:
            query_params.append(('current-page', params['current_page']))

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/jobs/sql-jobs', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='JobListResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def list_table_user_privileges(self, project_id, database_name, table_name, user_name, **kwargs):
        """
        List Table User Privileges
        Query the specified user's privileges list on the table.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_table_user_privileges(project_id, database_name, table_name, user_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: The database name to be queried. (required)
        :param str table_name: The name of the table to be queried. (required)
        :param str user_name: The name of the user to be queried. (required)
        :param str x_auth_token: Authorization Token.
        :return: PrivilegeResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.list_table_user_privileges_with_http_info(project_id, database_name, table_name, user_name, **kwargs)
        else:
            (data) = self.list_table_user_privileges_with_http_info(project_id, database_name, table_name, user_name, **kwargs)
            return data

    def list_table_user_privileges_with_http_info(self, project_id, database_name, table_name, user_name, **kwargs):
        """
        List Table User Privileges
        Query the specified user's privileges list on the table.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_table_user_privileges_with_http_info(project_id, database_name, table_name, user_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: The database name to be queried. (required)
        :param str table_name: The name of the table to be queried. (required)
        :param str user_name: The name of the user to be queried. (required)
        :param str x_auth_token: Authorization Token.
        :return: PrivilegeResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'database_name', 'table_name', 'user_name', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_table_user_privileges" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `list_table_user_privileges`")
        # verify the required parameter 'database_name' is set
        if ('database_name' not in params) or (params['database_name'] is None):
            raise ValueError("Missing the required parameter `database_name` when calling `list_table_user_privileges`")
        # verify the required parameter 'table_name' is set
        if ('table_name' not in params) or (params['table_name'] is None):
            raise ValueError("Missing the required parameter `table_name` when calling `list_table_user_privileges`")
        # verify the required parameter 'user_name' is set
        if ('user_name' not in params) or (params['user_name'] is None):
            raise ValueError("Missing the required parameter `user_name` when calling `list_table_user_privileges`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'database_name' in params:
            path_params['database_name'] = params['database_name']
        if 'table_name' in params:
            path_params['table_name'] = params['table_name']
        if 'user_name' in params:
            path_params['user_name'] = params['user_name']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/databases/{database_name}/tables/{table_name}/users/{user_name}', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='PrivilegeResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def list_table_users(self, project_id, database_name, table_name, **kwargs):
        """
        List Table Users
        View all users who have access to the columns of the specified table or table.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_table_users(project_id, database_name, table_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: The database name to be queried.. (required)
        :param str table_name: The name of the table to be queried. (required)
        :param str x_auth_token: Authorization Token.
        :return: PrivilegeResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.list_table_users_with_http_info(project_id, database_name, table_name, **kwargs)
        else:
            (data) = self.list_table_users_with_http_info(project_id, database_name, table_name, **kwargs)
            return data

    def list_table_users_with_http_info(self, project_id, database_name, table_name, **kwargs):
        """
        List Table Users
        View all users who have access to the columns of the specified table or table.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_table_users_with_http_info(project_id, database_name, table_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str database_name: The database name to be queried.. (required)
        :param str table_name: The name of the table to be queried. (required)
        :param str x_auth_token: Authorization Token.
        :return: PrivilegeResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'database_name', 'table_name', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_table_users" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `list_table_users`")
        # verify the required parameter 'database_name' is set
        if ('database_name' not in params) or (params['database_name'] is None):
            raise ValueError("Missing the required parameter `database_name` when calling `list_table_users`")
        # verify the required parameter 'table_name' is set
        if ('table_name' not in params) or (params['table_name'] is None):
            raise ValueError("Missing the required parameter `table_name` when calling `list_table_users`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'database_name' in params:
            path_params['database_name'] = params['database_name']
        if 'table_name' in params:
            path_params['table_name'] = params['table_name']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/databases/{database_name}/tables/{table_name}/users', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='PrivilegeResult',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def share_queue(self, project_id, privilege_info, **kwargs):
        """
        Share queues
        To share the specified queue with other users, you can assign the user the privilege to use the specified queue or to recover the usage privileges.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.share_queue(project_id, privilege_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param PrivilegeInfo privilege_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.share_queue_with_http_info(project_id, privilege_info, **kwargs)
        else:
            (data) = self.share_queue_with_http_info(project_id, privilege_info, **kwargs)
            return data

    def share_queue_with_http_info(self, project_id, privilege_info, **kwargs):
        """
        Share queues
        To share the specified queue with other users, you can assign the user the privilege to use the specified queue or to recover the usage privileges.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.share_queue_with_http_info(project_id, privilege_info, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param PrivilegeInfo privilege_info: Request parameters (required)
        :param str x_auth_token: Authorization Token.
        :return: ResponseInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'privilege_info', 'x_auth_token']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method share_queue" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `share_queue`")
        # verify the required parameter 'privilege_info' is set
        if ('privilege_info' not in params) or (params['privilege_info'] is None):
            raise ValueError("Missing the required parameter `privilege_info` when calling `share_queue`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'privilege_info' in params:
            body_params = params['privilege_info']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/queues/user-authorization', 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def store_job_result(self, project_id, job_id, **kwargs):
        """
        Export job result
        Export the results of the SQL statement to the OBS object store and only support the export of query results for \"QUERY\" type jobs.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.store_job_result(project_id, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :param ExportCommonInfo export_common_info: Request parameters
        :return: ResponseJobInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.store_job_result_with_http_info(project_id, job_id, **kwargs)
        else:
            (data) = self.store_job_result_with_http_info(project_id, job_id, **kwargs)
            return data

    def store_job_result_with_http_info(self, project_id, job_id, **kwargs):
        """
        Export job result
        Export the results of the SQL statement to the OBS object store and only support the export of query results for \"QUERY\" type jobs.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.store_job_result_with_http_info(project_id, job_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str project_id: Project ID for resource isolation. (required)
        :param str job_id: Job ID. (required)
        :param str x_auth_token: Authorization Token.
        :param ExportCommonInfo export_common_info: Request parameters
        :return: ResponseJobInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id', 'job_id', 'x_auth_token', 'export_common_info']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method store_job_result" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params) or (params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `store_job_result`")
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params) or (params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `store_job_result`")


        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['project_id'] = params['project_id']
        if 'job_id' in params:
            path_params['job_id'] = params['job_id']

        query_params = []

        header_params = {}
        if 'x_auth_token' in params:
            header_params['X-Auth-Token'] = params['x_auth_token']

        form_params = []
        local_var_files = {}

        body_params = None
        if 'export_common_info' in params:
            body_params = params['export_common_info']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/{project_id}/jobs/{job_id}/export-result', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ResponseJobInfo',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
