#!/usr/bin/python
# -*- coding: UTF-8 -*-
from dli.exception import DliException


class ResultSetIterator(object):
    def __init__(self, result_set):
        self._result_set = result_set
        self._index = 0

    def __iter__(self):
        return self

    def __next__(self):
        return self.next()

    def next(self):
        try:
            row = self._result_set.get_row(self._index)
        except IndexError:
            raise StopIteration()

        self._index += 1
        return row


class ResultSet(object):
    def __init__(self, job, rows=None, schema=None):
        self._job = job
        self._rows = rows
        self._schema = schema
        self._row_idx = 0
        self._row_count = 0

        if rows:
            self._row_count = len(rows)

    def __iter__(self):
        return ResultSetIterator(self)

    def get_row(self, index):
        if self._rows is None:
            message = 'DLI server response error, rows is None'
            raise DliException(msg=message)

        return self._rows[index]

    @property
    def row_count(self):
        return self._row_count
